import * as i0 from '@angular/core';
import { Injectable, EventEmitter, Component, Input, Output, NgModule } from '@angular/core';
import * as i2 from '@angular/forms';
import { FormGroup, FormControl, Validators, ReactiveFormsModule, FormsModule } from '@angular/forms';
import * as i1 from '@angular/common';
import { CommonModule } from '@angular/common';

class Angular14JsonFormService {
    constructor() { }
}
Angular14JsonFormService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: Angular14JsonFormService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
Angular14JsonFormService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: Angular14JsonFormService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: Angular14JsonFormService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class Angular14JsonFormComponent {
    constructor() {
        this.title = '';
        this.subTitle = '';
        this.itemPerRow = 1;
        this.fields = [];
        this.submitHandler = new EventEmitter();
        this.fieldChangeHandler = new EventEmitter();
        this.globalColumnClass = 'col-span-12';
    }
    ngOnInit() {
        let form = [];
        if (this.itemPerRow !== 1) {
            this.globalColumnClass = 'col-span-' + (12 / this.itemPerRow);
        }
        this.fields.map((field) => {
            form[field.name] = this.createCustomFormControl('', field);
        });
        this.jsonForm = new FormGroup(form);
    }
    onSubmit() {
        this.submitHandler.emit(this.jsonForm);
    }
    onFieldValueChange(field, value) {
        this.fieldChangeHandler.emit({
            field: field,
            value: value
        });
    }
    createCustomFormControl(value, options) {
        const { required, readonly, disabled, defaultValue } = options;
        const control = new FormControl(value);
        if (required) {
            control.setValidators([Validators.required]);
        }
        if (readonly) {
            control.disable();
        }
        if (disabled) {
            control.disable();
        }
        if (defaultValue !== undefined) {
            control.setValue(defaultValue);
        }
        return control;
    }
}
Angular14JsonFormComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: Angular14JsonFormComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
Angular14JsonFormComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.3.0", type: Angular14JsonFormComponent, selector: "angular14-json-form", inputs: { title: "title", subTitle: "subTitle", itemPerRow: "itemPerRow", fields: "fields" }, outputs: { submitHandler: "submitHandler", fieldChangeHandler: "fieldChangeHandler" }, ngImport: i0, template: "<div class=\"\" *ngIf=\"jsonForm\">\n  <div class=\"min-w-[400px]\">\n    <form class=\"\" [formGroup]=\"jsonForm\" (ngSubmit)=\"onSubmit()\">\n      <h2 class=\"text-2xl\">{{ title }}</h2>\n      <p>{{ subTitle }}</p>\n      <div class=\"my-4\">\n        <div class=\"grid grid-cols-12 gap-4\">\n          <div *ngFor=\"let field of fields\" [ngClass]=\"[\n              (field.filedWidth === null)?globalColumnClass:('col-span-'+12*field.filedWidth),\n              (field.customClass !== '')?field.customClass:''\n            ]\">\n            <div *ngIf=\"field.type === 'checkbox' && field.isVisible\">\n              <label class=\"inline-flex items-center\">\n                <input formControlName=\"{{field.name}}\" type=\"checkbox\" class=\" rounded border-gray-300 text-indigo-600 shadow-sm focus:border-indigo-300 focus:ring focus:ring-offset-0 focus:ring-indigo-200 focus:ring-opacity-50\" formControlName=\"name\" (change)=\"onFieldValueChange(field, $event)\" [ngClass]=\"field.customClass\">\n                <span class=\"ml-2\">Email me news and special offers</span>\n              </label>\n            </div>\n            <div *ngIf=\"field.type === 'date' && field.isVisible\">\n              <label class=\"block\">\n                <span class=\"text-gray-700\">{{field.label}} <span *ngIf=\"field.required\" class=\"text-rose-500\">*</span></span>\n                <input formControlName=\"{{field.name}}\" type=\"date\" class=\" mt-1 block w-full rounded-md border-gray-300 shadow-sm focus:border-indigo-300 focus:ring focus:ring-indigo-200 focus:ring-opacity-50\" (change)=\"onFieldValueChange(field, $event)\" [ngClass]=\"field.customClass\">\n              </label>\n            </div>\n            <div *ngIf=\"field.type === 'file' && field.isVisible\">\n              <label class=\"block\">\n                <span class=\"text-gray-700\">{{field.label}} <span *ngIf=\"field.required\" class=\"text-rose-500\">*</span></span>\n                <input formControlName=\"{{field.name}}\" type=\"file\" class=\" mt-1 block w-full rounded-md border-gray-300 shadow-sm focus:border-indigo-300 focus:ring focus:ring-indigo-200 focus:ring-opacity-50\" placeholder=\"{{field.placeholder}}\" (change)=\"onFieldValueChange(field, $event)\" [ngClass]=\"field.customClass\">\n              </label>\n            </div>\n            <div *ngIf=\"field.type === 'number' && field.isVisible\">\n              <label class=\"block\">\n                <span class=\"text-gray-700\">{{field.label}} <span *ngIf=\"field.required\" class=\"text-rose-500\">*</span></span>\n                <input formControlName=\"{{field.name}}\" type=\"number\" class=\" mt-1 block w-full rounded-md border-gray-300 shadow-sm focus:border-indigo-300 focus:ring focus:ring-indigo-200 focus:ring-opacity-50\" placeholder=\"{{field.placeholder}}\" (change)=\"onFieldValueChange(field, $event)\" [ngClass]=\"field.customClass\">\n              </label>\n            </div>\n            <div *ngIf=\"field.type === 'password' && field.isVisible\">\n              <label class=\"block\">\n                <span class=\"text-gray-700\">{{field.label}} <span *ngIf=\"field.required\" class=\"text-rose-500\">*</span></span>\n                <input formControlName=\"{{field.name}}\" type=\"password\" class=\" mt-1 block w-full rounded-md border-gray-300 shadow-sm focus:border-indigo-300 focus:ring focus:ring-indigo-200 focus:ring-opacity-50\" placeholder=\"{{field.placeholder}}\" (change)=\"onFieldValueChange(field, $event)\" [ngClass]=\"field.customClass\">\n              </label>\n            </div>\n            <div *ngIf=\"field.type === 'radio' && field.isVisible\">\n              <label class=\"inline-flex items-center mr-2\" *ngFor=\"let option of field.options\">\n                <input formControlName=\"{{field.name}}\" type=\"radio\" class=\"form-radio text-indigo-600\" value=\"{{option.value}}\" (change)=\"onFieldValueChange(field, $event)\" [ngClass]=\"field.customClass\">\n                <span class=\"ml-2\">{{option.label}}</span>\n              </label>\n            </div>\n            <div *ngIf=\"field.type === 'range' && field.isVisible\">\n              <p>Range input not supported right now!</p>\n            </div>\n            <div *ngIf=\"field.type === 'select' && field.isVisible\">\n              <label class=\"block\">\n                <span class=\"text-gray-700\">{{field.label}} <span *ngIf=\"field.required\" class=\"text-rose-500\">*</span></span>\n                <select formControlName=\"{{field.name}}\" class=\" block w-full mt-1 rounded-md border-gray-300 shadow-sm focus:border-indigo-300 focus:ring focus:ring-indigo-200 focus:ring-opacity-50\" [ngClass]=\"field.customClass\">\n                  <option *ngFor=\"let option of field.options\" value=\"{{option.value}}\">{{option.label}}</option>\n                </select>\n              </label>\n            </div>\n            <div *ngIf=\"field.type === 'submit' && field.isVisible\">\n              <label class=\"block\">\n                <span class=\"text-gray-700\">{{field.label}} <span *ngIf=\"field.required\" class=\"text-rose-500\">*</span></span>\n                <input\n                  type=\"submit\"\n                  class=\" mt-1 block w-full rounded-md border-gray-300 shadow-sm focus:border-indigo-300 focus:ring focus:ring-indigo-200 focus:ring-opacity-50\"\n                  placeholder=\"{{field.placeholder}}\"\n                  [ngClass]=\"field.customClass\"\n                >\n              </label>\n            </div>\n            <div *ngIf=\"field.type === 'text' && field.isVisible\">\n              <label class=\"block\">\n                <span class=\"text-gray-700\">{{field.label}} <span *ngIf=\"field.required\" class=\"text-rose-500\">*</span></span>\n                <input\n                  type=\"text\"\n                  class=\" mt-1 block w-full rounded-md border-gray-300 shadow-sm focus:border-indigo-300 focus:ring focus:ring-indigo-200 focus:ring-opacity-50\"\n                  placeholder=\"{{field.placeholder}}\"\n                  formControlName=\"{{field.name}}\"\n                  [ngClass]=\"field.customClass\"\n                  (change)=\"onFieldValueChange(field, $event)\"\n                >\n              </label>            </div>\n            <div *ngIf=\"field.type === 'textarea' && field.isVisible\">\n              <label class=\"block\">\n                <span class=\"text-gray-700\">{{field.label}} <span *ngIf=\"field.required\" class=\"text-rose-500\">*</span></span>\n                <textarea\n                  formControlName=\"{{field.name}}\"\n                  class=\" mt-1 block w-full rounded-md border-gray-300 shadow-sm focus:border-indigo-300 focus:ring focus:ring-indigo-200 focus:ring-opacity-50\"\n                  [ngClass]=\"field.customClass\"\n                  rows=\"3\"></textarea>\n              </label>\n            </div>\n          </div>\n        </div>\n      </div>\n    </form>\n  </div>\n</div>\n", styles: [""], dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { kind: "directive", type: i2.NgSelectOption, selector: "option", inputs: ["ngValue", "value"] }, { kind: "directive", type: i2.ɵNgSelectMultipleOption, selector: "option", inputs: ["ngValue", "value"] }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NumberValueAccessor, selector: "input[type=number][formControlName],input[type=number][formControl],input[type=number][ngModel]" }, { kind: "directive", type: i2.CheckboxControlValueAccessor, selector: "input[type=checkbox][formControlName],input[type=checkbox][formControl],input[type=checkbox][ngModel]" }, { kind: "directive", type: i2.SelectControlValueAccessor, selector: "select:not([multiple])[formControlName],select:not([multiple])[formControl],select:not([multiple])[ngModel]", inputs: ["compareWith"] }, { kind: "directive", type: i2.RadioControlValueAccessor, selector: "input[type=radio][formControlName],input[type=radio][formControl],input[type=radio][ngModel]", inputs: ["name", "formControlName", "value"] }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { kind: "directive", type: i2.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { kind: "directive", type: i2.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: Angular14JsonFormComponent, decorators: [{
            type: Component,
            args: [{ selector: 'angular14-json-form', template: "<div class=\"\" *ngIf=\"jsonForm\">\n  <div class=\"min-w-[400px]\">\n    <form class=\"\" [formGroup]=\"jsonForm\" (ngSubmit)=\"onSubmit()\">\n      <h2 class=\"text-2xl\">{{ title }}</h2>\n      <p>{{ subTitle }}</p>\n      <div class=\"my-4\">\n        <div class=\"grid grid-cols-12 gap-4\">\n          <div *ngFor=\"let field of fields\" [ngClass]=\"[\n              (field.filedWidth === null)?globalColumnClass:('col-span-'+12*field.filedWidth),\n              (field.customClass !== '')?field.customClass:''\n            ]\">\n            <div *ngIf=\"field.type === 'checkbox' && field.isVisible\">\n              <label class=\"inline-flex items-center\">\n                <input formControlName=\"{{field.name}}\" type=\"checkbox\" class=\" rounded border-gray-300 text-indigo-600 shadow-sm focus:border-indigo-300 focus:ring focus:ring-offset-0 focus:ring-indigo-200 focus:ring-opacity-50\" formControlName=\"name\" (change)=\"onFieldValueChange(field, $event)\" [ngClass]=\"field.customClass\">\n                <span class=\"ml-2\">Email me news and special offers</span>\n              </label>\n            </div>\n            <div *ngIf=\"field.type === 'date' && field.isVisible\">\n              <label class=\"block\">\n                <span class=\"text-gray-700\">{{field.label}} <span *ngIf=\"field.required\" class=\"text-rose-500\">*</span></span>\n                <input formControlName=\"{{field.name}}\" type=\"date\" class=\" mt-1 block w-full rounded-md border-gray-300 shadow-sm focus:border-indigo-300 focus:ring focus:ring-indigo-200 focus:ring-opacity-50\" (change)=\"onFieldValueChange(field, $event)\" [ngClass]=\"field.customClass\">\n              </label>\n            </div>\n            <div *ngIf=\"field.type === 'file' && field.isVisible\">\n              <label class=\"block\">\n                <span class=\"text-gray-700\">{{field.label}} <span *ngIf=\"field.required\" class=\"text-rose-500\">*</span></span>\n                <input formControlName=\"{{field.name}}\" type=\"file\" class=\" mt-1 block w-full rounded-md border-gray-300 shadow-sm focus:border-indigo-300 focus:ring focus:ring-indigo-200 focus:ring-opacity-50\" placeholder=\"{{field.placeholder}}\" (change)=\"onFieldValueChange(field, $event)\" [ngClass]=\"field.customClass\">\n              </label>\n            </div>\n            <div *ngIf=\"field.type === 'number' && field.isVisible\">\n              <label class=\"block\">\n                <span class=\"text-gray-700\">{{field.label}} <span *ngIf=\"field.required\" class=\"text-rose-500\">*</span></span>\n                <input formControlName=\"{{field.name}}\" type=\"number\" class=\" mt-1 block w-full rounded-md border-gray-300 shadow-sm focus:border-indigo-300 focus:ring focus:ring-indigo-200 focus:ring-opacity-50\" placeholder=\"{{field.placeholder}}\" (change)=\"onFieldValueChange(field, $event)\" [ngClass]=\"field.customClass\">\n              </label>\n            </div>\n            <div *ngIf=\"field.type === 'password' && field.isVisible\">\n              <label class=\"block\">\n                <span class=\"text-gray-700\">{{field.label}} <span *ngIf=\"field.required\" class=\"text-rose-500\">*</span></span>\n                <input formControlName=\"{{field.name}}\" type=\"password\" class=\" mt-1 block w-full rounded-md border-gray-300 shadow-sm focus:border-indigo-300 focus:ring focus:ring-indigo-200 focus:ring-opacity-50\" placeholder=\"{{field.placeholder}}\" (change)=\"onFieldValueChange(field, $event)\" [ngClass]=\"field.customClass\">\n              </label>\n            </div>\n            <div *ngIf=\"field.type === 'radio' && field.isVisible\">\n              <label class=\"inline-flex items-center mr-2\" *ngFor=\"let option of field.options\">\n                <input formControlName=\"{{field.name}}\" type=\"radio\" class=\"form-radio text-indigo-600\" value=\"{{option.value}}\" (change)=\"onFieldValueChange(field, $event)\" [ngClass]=\"field.customClass\">\n                <span class=\"ml-2\">{{option.label}}</span>\n              </label>\n            </div>\n            <div *ngIf=\"field.type === 'range' && field.isVisible\">\n              <p>Range input not supported right now!</p>\n            </div>\n            <div *ngIf=\"field.type === 'select' && field.isVisible\">\n              <label class=\"block\">\n                <span class=\"text-gray-700\">{{field.label}} <span *ngIf=\"field.required\" class=\"text-rose-500\">*</span></span>\n                <select formControlName=\"{{field.name}}\" class=\" block w-full mt-1 rounded-md border-gray-300 shadow-sm focus:border-indigo-300 focus:ring focus:ring-indigo-200 focus:ring-opacity-50\" [ngClass]=\"field.customClass\">\n                  <option *ngFor=\"let option of field.options\" value=\"{{option.value}}\">{{option.label}}</option>\n                </select>\n              </label>\n            </div>\n            <div *ngIf=\"field.type === 'submit' && field.isVisible\">\n              <label class=\"block\">\n                <span class=\"text-gray-700\">{{field.label}} <span *ngIf=\"field.required\" class=\"text-rose-500\">*</span></span>\n                <input\n                  type=\"submit\"\n                  class=\" mt-1 block w-full rounded-md border-gray-300 shadow-sm focus:border-indigo-300 focus:ring focus:ring-indigo-200 focus:ring-opacity-50\"\n                  placeholder=\"{{field.placeholder}}\"\n                  [ngClass]=\"field.customClass\"\n                >\n              </label>\n            </div>\n            <div *ngIf=\"field.type === 'text' && field.isVisible\">\n              <label class=\"block\">\n                <span class=\"text-gray-700\">{{field.label}} <span *ngIf=\"field.required\" class=\"text-rose-500\">*</span></span>\n                <input\n                  type=\"text\"\n                  class=\" mt-1 block w-full rounded-md border-gray-300 shadow-sm focus:border-indigo-300 focus:ring focus:ring-indigo-200 focus:ring-opacity-50\"\n                  placeholder=\"{{field.placeholder}}\"\n                  formControlName=\"{{field.name}}\"\n                  [ngClass]=\"field.customClass\"\n                  (change)=\"onFieldValueChange(field, $event)\"\n                >\n              </label>            </div>\n            <div *ngIf=\"field.type === 'textarea' && field.isVisible\">\n              <label class=\"block\">\n                <span class=\"text-gray-700\">{{field.label}} <span *ngIf=\"field.required\" class=\"text-rose-500\">*</span></span>\n                <textarea\n                  formControlName=\"{{field.name}}\"\n                  class=\" mt-1 block w-full rounded-md border-gray-300 shadow-sm focus:border-indigo-300 focus:ring focus:ring-indigo-200 focus:ring-opacity-50\"\n                  [ngClass]=\"field.customClass\"\n                  rows=\"3\"></textarea>\n              </label>\n            </div>\n          </div>\n        </div>\n      </div>\n    </form>\n  </div>\n</div>\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { title: [{
                type: Input,
                args: ['title']
            }], subTitle: [{
                type: Input,
                args: ['subTitle']
            }], itemPerRow: [{
                type: Input,
                args: ['itemPerRow']
            }], fields: [{
                type: Input,
                args: ['fields']
            }], submitHandler: [{
                type: Output,
                args: ['submitHandler']
            }], fieldChangeHandler: [{
                type: Output,
                args: ['fieldChangeHandler']
            }] } });

class Angular14JsonFormModule {
}
Angular14JsonFormModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: Angular14JsonFormModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
Angular14JsonFormModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.3.0", ngImport: i0, type: Angular14JsonFormModule, declarations: [Angular14JsonFormComponent], imports: [CommonModule,
        ReactiveFormsModule,
        FormsModule], exports: [Angular14JsonFormComponent] });
Angular14JsonFormModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: Angular14JsonFormModule, imports: [CommonModule,
        ReactiveFormsModule,
        FormsModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: Angular14JsonFormModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        Angular14JsonFormComponent,
                    ],
                    imports: [
                        CommonModule,
                        ReactiveFormsModule,
                        FormsModule
                    ],
                    exports: [
                        Angular14JsonFormComponent
                    ]
                }]
        }] });

/*
 * Public API Surface of angular14-json-form
 */

/**
 * Generated bundle index. Do not edit.
 */

export { Angular14JsonFormComponent, Angular14JsonFormModule, Angular14JsonFormService };
//# sourceMappingURL=angular14-json-form.mjs.map
